/* @flow */

import validity from './validity'

export default function (Vue: GlobalAPI): Object {
  const { extend } = Vue.util
  const validityComponent = validity(Vue)

  const validifyFunctional: Object = {
    functional: true,
    render (h: Function, {
      props,
      data,
      children
    }): Array<VNode> {
      console.log('validity#render', props, data)
      return children().map((child: VNode) => {
        if (!child.tag) {
          return child
        } else {
          const newData: VNodeData = extend({}, data)
          newData.props = extend({}, props)
          newData.props.child = child
          return h(validityComponent, newData)
        }
      })
    }
  }

  return validifyFunctional
}
