/* @flow */

export default function (Vue: GlobalAPI): Object {
  const validity: {
    name: string,
    props: Object,
    data: Function,
    render: Function
  } = {
    name: 'validity',
    props: {
      child: {
        type: Object,
        required: true
      },
      validators: {
        type: [String, Array, Object],
        required: true
      }
    },
    data () {
      return {
        results: [],
        dirty: false,
        touched: false,
        modified: false
      }
    },
    render (h: Function): VNode {
      console.log(`${this._uid}#render`, this, this.child)
      return this.child
    }
  }

  return validity
}
